"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

require("./App.css");

var _ChatWindow = _interopRequireDefault(require("./components/ChatWindow"));

var _ChatIcon = _interopRequireDefault(require("./components/ChatIcon"));

var _sampleData = require("./dataProvider/sampleData");

var _botResponse = _interopRequireDefault(require("./models/botResponse"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var contextManager = require("./stateManager/manageSession");

function ChatbotWindow() {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isConnected = _useState2[0],
      setIsConnected = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = _slicedToArray(_useState3, 2),
      chatHistory = _useState4[0],
      setChatHistory = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      openChatWindow = _useState6[0],
      setOpenChatWindow = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      messageLoader = _useState8[0],
      setMessageLoader = _useState8[1];

  (0, _react.useEffect)(function () {
    if (openChatWindow) {
      setTimeout(function () {
        console.log("loading chat history if any");
        setIsConnected(true); // fetch the conversation data from the database, set true if success else false

        if (chatHistory.length === 0) {
          (0, _sampleData.conversations)("welcome").then(function (res) {
            console.log("welcome res obj > ", res);
            contextManager.cachePreviousState(res);
            var welcomeMessage = (0, _botResponse["default"])(res); // console.log("welcomeMessage > ", welcomeMessage);

            setChatHistory([].concat(_toConsumableArray(chatHistory), [welcomeMessage])); // set the conversation data
          })["catch"](function (e) {
            console.log("error while setting the conversations >", e);
          });
        }
      }, 500);
    }
  }, [openChatWindow]);

  function handleUserMessage(userResponse) {
    setMessageLoader(true);
    appendMessage(userResponse); // botResponse(userResponse.text);

    (0, _sampleData.conversations)(userResponse.message.toLowerCase()).then(function (res) {
      // console.log("handleUserMessage res >> ", res);
      var botResp = (0, _botResponse["default"])(res);
      var delay = 500;
      setTimeout(function () {
        appendMessage(botResp);
        setMessageLoader(false);
      }, delay);
    })["catch"](function (e) {
      console.log("error while setting the conversations >", e);
    });
  }

  function appendMessage(message) {
    console.log("appending message to chathistory");
    setChatHistory(function (oldData) {
      return [].concat(_toConsumableArray(oldData), [message]);
    });
  }

  function handleChatIconClick() {
    contextManager.createConversationId();
    setOpenChatWindow(!openChatWindow);
  } // function botResponse(userMsg) {
  //   conversations(userMsg.toLowerCase()).then(res => {
  //     console.log("welcome res > ", res);
  //     const botResp = generateBotResponse(res);
  //     const delay = 500;
  //     setTimeout(() => {
  //       appendMessage(botResp);
  //       setMessageLoader(false);
  //     }, delay);
  //   }).catch(e => {
  //     console.log("error while setting the conversations >", e);
  //   });
  // }


  function handleMinimizeWindow() {
    contextManager.getConversationId();
    setOpenChatWindow(false);
  }

  function closeConversation() {
    setOpenChatWindow(false);
    setChatHistory([]);
    setIsConnected(false);
  }

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, openChatWindow ? /*#__PURE__*/_react["default"].createElement(_ChatWindow["default"], {
    theme: "blue",
    title: "efia",
    chatHistory: chatHistory,
    isConnected: isConnected,
    minimizeWindow: handleMinimizeWindow,
    closeConversation: closeConversation,
    handleUserResponse: handleUserMessage,
    enableMessageLoader: messageLoader,
    windowSize: "large"
  }) : /*#__PURE__*/_react["default"].createElement(_ChatIcon["default"], {
    onClick: handleChatIconClick
  }));
}

var _default = ChatbotWindow;
exports["default"] = _default;